/*
 * DrvPMU.h
 *
 *  Created on: 2011/11/28
 *      Author: Eric.Lai
 */

#ifndef DRVPMU_H_
#define DRVPMU_H_

#include "HY16F188.h"


#ifndef E_FAIL
#define E_FAIL		1
#endif
#define E_DRVPMU_ARGUMENT E_FAIL

#ifndef E_SUCCESS
#define E_SUCCESS		0
#endif

#ifdef PMU_BASE
#define PMU_CTRL     (PMU_BASE+OFFSET00)
#endif

typedef enum
{
	E_VDDA2_4 = 0,
	E_VDDA2_7 = 1,
	E_VDDA3_0 = 2,
	E_VDDA3_3 = 3
} E_VDDA_OUTPUT_VOLTAGE;

typedef enum
{
	E_HighZ     = 0,
	E_VDD3V     = 1,
	E_PullDown  = 2,
	E_LDO      = 3
} E_VDDA_LDO_ENABLE_CONTROL;

#define VDAS     			18
#define ENVA     			16
#define ENBGR               4
#define ACMS     			3
#define ENCHP     			2
#define ENRFO     			1
#define VDDLP     			0
#define VDAS_MASK 			(VDAS+MASK)
#define ENVA_MASK  			(ENVA+MASK)
#define ENBGR_MASK          (ENBGR+MASK)
#define ACMS_MASK   		(ACMS+MASK)
#define ENCHP_MASK  		(ENCHP+MASK)
#define ENRFO_MASK  		(ENRFO+MASK)
#define VDDLP_MASK  		(VDDLP+MASK)
#define VDAS_MAX            3
#define ENVA_MAX            3
#define ACMS_MAX   		    1
#define VDDLP_MAX           1

unsigned int DrvPMU_VDDA_Voltage(unsigned int uVoltage);
unsigned int DrvPMU_VDDA_LDO_Ctrl(unsigned int uCtrl);
void DrvPMU_BandgapEnable(void);
void DrvPMU_BandgapDisable(void);
void DrvPMU_ChargePumpEnable(void);
void DrvPMU_ChargePumpDisable(void);
void DrvPMU_REFO_Enable(void);
void DrvPMU_REFO_Disable(void);
unsigned int DrvPMU_AnalogGround(unsigned int uAG);
unsigned int DrvPMU_LDO_LowPower(unsigned int uLP);

#endif /* DRVPMU_H_ */
